
//--------------------------------------------------------------
// VS4UIvVݒ
//--------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <math.h>
#include <windows.h>

#include "vslib.h"
#include "vs4u.h"


//--------------------------------------------------------------
// IvVݒ
//
// 
//  int		argc		̐
//  char	*argv[]		
//  VS4UOPTION *option	IvV
//
// ߂l
//  0: 1:s
//
// Tv
//  R}hCǂݏoAIvVݒ肷B
//--------------------------------------------------------------
int Vs4uGetOption( int argc, char *argv[], VS4UOPTION *option )
{
#if 0
	printf( "argc = %d\n", argc );
	for ( int i=1; i<argc; i++ ){
		printf( "%d = %s\n", i, argv[i] );
	}
#endif

	// IvV
	memset( option, 0, sizeof(VS4UOPTION) );
	option->peekCmp = 86;
	option->breathiness = 50;

	// 1.̓t@C
	strcpy_s( option->inputWaveFile, VS4U_MAX_PATH, argv[1] );

	// 2.o̓t@C
	strcpy_s( option->outputWaveFile, VS4U_MAX_PATH, argv[2] );

	// 3.K
	option->noteNum = Vs4uCnvNoteNum( argv[3] );

	// 4.̕ω(qx)
	option->fixSpeed = LimitDoubleValue( atof( argv[4] ), 0.0, 400.0 );

	// 5.tO
	Vs4uSetFlgOption( argv[5], option );

	// 6.ItZbg
	option->offset = atof( argv[6] );

	// 7.v
	option->reqLength = atof( argv[7] );

	// 8.q
	option->fixedLength = atof( argv[8] );

	// 9.uN
	option->endBlank = atof( argv[9] );

	// 10.{[
	option->volume = LimitDoubleValue( atof( argv[10] ), 0.0, 200.0 );

	// 11.W[V
	option->modulation = LimitDoubleValue( atof( argv[11] ), -400.0, 400.0 );

	// 12`13.sb`xh
	if( argc >= 13 ){
		Vs4uSetPitchBendOption( argv, option );
	}

	// Ǝg\t@Cݒ
	strcpy_s( option->vsfrqFile, VS4U_MAX_PATH, option->inputWaveFile );
	AddExtStr( option->vsfrqFile, VS4U_MAX_PATH, ".vs4ufrq" );

	// Wg\t@Cݒ
	strcpy_s( option->frqFile, VS4U_MAX_PATH, option->inputWaveFile );
	AddExtStr( option->frqFile, VS4U_MAX_PATH, ".frq" );

	// vWFNgt@Cݒ
	strcpy_s( option->vspFile, VS4U_MAX_PATH, option->outputWaveFile );
	AddExtStr( option->vspFile, VS4U_MAX_PATH, ".vshp" );
	
	return 0;
}


//--------------------------------------------------------------
// Km[gio[ɕϊ
//
// 
//  char *nnStr		K(C0`B9)
//
// ߂l
//  m[gio[(C4=60Ƃ锼P)
//
// Tv
//  Km[gio[ɕϊB
//--------------------------------------------------------------
int Vs4uCnvNoteNum( char *nnStr )
{
	int noteNum = 0;		// m[gio[
	int octStrOffset = 1;	// IN^[ũCfbNX

	// K񒷂`FbN
	int length = strlen( nnStr );
	if( length < 2 ){
		return 60;
	}

	// Km[gio[ɕϊ
	switch( nnStr[0] ){
	case 'C':
		noteNum = 0;
		break;
	case 'D':
		noteNum = 2;
		break;
	case 'E':
		noteNum = 4;
		break;
	case 'F':
		noteNum = 5;
		break;
	case 'G':
		noteNum = 7;
		break;
	case 'A':
		noteNum = 9;
		break;
	case 'B':
		noteNum = 11;
		break;
	default:
		noteNum = 0;
		break;
	}

	// #Δグ
	if( nnStr[1] == '#' ){
		noteNum++;
		octStrOffset = 2;
	}

	// IN^[uϊ
	if( length > octStrOffset ){
		int oct = nnStr[octStrOffset]-'0';
		if( oct < 0 ){
			oct = 0;
		}
		else if( oct > 10 ){
			oct = 10;
		}
		noteNum += (oct+1)*12;
	}

	return noteNum;
}


//--------------------------------------------------------------
// tOŃIvVݒ
//
// 
//  char *flgStr	tO
//
// ߂l
//  0: 1:s
//
// Tv
//  tOŃIvVݒ肷B
//--------------------------------------------------------------
int Vs4uSetFlgOption( char *flgStr, VS4UOPTION *option )
{
	int length = strlen( flgStr );

	// ݒ
	int offset = 0;	// ǂݏoʒu
	for(;;){
		// I
		if( offset == length ){
			break;
		}

		// tOʓǂݏo
		char flg = flgStr[offset];
		offset++;

		// tOl̕񒷂Zo
		int valueLength = 0;
		for(;;){
			// I[ɓB
			if( offset+valueLength == length ){
				break;
			}
			// ̃tO(At@xbg)ɓB
			if( isalpha( flgStr[offset+valueLength] ) ){
				break;
			}
			valueLength++;
		}

		// tOl𐔒lɕϊ
		int valueData = 0;
		if( ( valueLength > 0 ) && ( valueLength < 32 ) ){
			char tmpStr[32];
			memcpy_s( tmpStr, 32, flgStr+offset, valueLength );
			tmpStr[valueLength] = 0;
			valueData = atoi( tmpStr );
			offset += valueLength;
		}

		// tOݒ
		switch( flg ){
		case 'N':
			option->noFormantFlg = 1;
			break;
		case 'g':
			option->genderFactor = LimitIntValue( valueData, -100, 100 );
			break;
		case 't':
			option->pitchShift = LimitIntValue( valueData, -240, 240 );
			break;
		case 'T':
			option->pitchShift2 = LimitIntValue( valueData, -2400, 2400 );
			break;
		case 'P':
			option->peekCmp = LimitIntValue( valueData, 0, 100 );
			break;
		case 'H':
			option->lowPassfilter = LimitIntValue( valueData, 0, 99 );
			break;
		case 'B':
			option->breathiness = LimitIntValue( valueData, 0, 100 );
			break;
		case 'O':
			option->brightness = LimitIntValue( valueData, -100, 100 );
			break;
		case 'S':
			option->clearness = LimitIntValue( valueData, -100, 100 );
			break;
		case 'Z':
			option->outputVshpFlg = valueData;
			break;
#if 0
		case 'V':
			option->reGenerateFrqFlg = 1;
			break;
#endif
		case 'W':
			option->disablePitchShift = valueData;
			break;
		}
	}

	return 0;
}


//--------------------------------------------------------------
// Base64fR[h
//
// 
//  char *str	
//
// ߂l
//  fR[hl
//
// Tv
//  2BASE64fR[hA-2048`2047̒lԂB
//--------------------------------------------------------------
int Vs4uDecodeBase64( char *str )
{
	int value = 0;

	for( int i=0; i<2; i++ ){
		int c = str[i];
		int v = 0;

		if( ( c >= 'A' ) && ( c <= 'Z' ) ){
			v = c-'A';
		}
		else if( ( c >= 'a' ) && ( c <= 'z' ) ){
			v = c-'a'+26;
		}
		else if( ( c >= '0' ) && ( c <= '9' ) ){
			v = c-'0'+52;
		}
		else if( c == '+' ){
			v = 62;
		}
		else if( c == '/' ){
			v = 63;
		}

		value = value*64+v;
	}

	if( value >= 2048 ){
		value -= 4096;
	}

	return value;
}


//--------------------------------------------------------------
// sb`xhIvVݒ
//
// 
//  int		argc		̐
//  char	*argv[]		
//  VS4UOPTION *option	IvV
//
// ߂l
//  0: 1:s
//
// Tv
//  R}hCǂݏoAsb`xhIvVݒ肷B
//--------------------------------------------------------------
int Vs4uSetPitchBendOption( char *argv[], VS4UOPTION *option )
{
	char *pitchBendStr = argv[12];
	option->tempo = 0.0;
	
	// e|ǂݏo
	if( pitchBendStr[0] == '!' ){
		option->tempo = atof( pitchBendStr+1 );
		pitchBendStr = argv[13];
	}

	// sb`xhf[^ǂݏo
	int length = strlen( pitchBendStr );	// 
	int nData = 0;		// f[^
	int offset = 0;		// ǂݏoʒu
	int lastData = 0;	// Õf[^(OXp)

	for(;;){
		// I
		if( offset >= length ){
			break;
		}

		if( pitchBendStr[offset] == '#' ){
			// OX񒷎Zo
			int i = offset+1;
			int offset2 = i;
			for(;;){
				if( i == length ){
					break;
				}
				if( pitchBendStr[i] == '#' ){
					offset2 = i;
					break;
				}
				i++;
			}
			int repNumLength = offset2-offset-1;

			// OXZo,f[^ݒ
			int repNum = 0;
			if( repNumLength < 8 ){
				char tmp[8];
				memcpy_s( tmp, 8, pitchBendStr+offset+1, repNumLength );
				tmp[repNumLength] = NULL;
				repNum = atoi( tmp );
				for( int i=0; i<repNum; i++ ){
					if( nData+i < VS4U_PBSIZE ){
						option->pitchBend[nData+i] = lastData;
					}
					else{
						break;
					}
				}
			}

			nData += repNum;
			offset = offset2+1;
		}
		else{
			// ڎw
			if( length >= offset+2 ){
				lastData = Vs4uDecodeBase64( pitchBendStr+offset );
				if( nData < VS4U_PBSIZE ){
					option->pitchBend[nData] = lastData;
				}
				nData++;
				offset += 2;
			}
			else{
				break;
			}
		}
	}

	// f[^ݒ
	if( nData > VS4U_PBSIZE ){
		nData = VS4U_PBSIZE;
	}
	option->nPitchBend = nData;

	return 0;
}


#ifdef PRINT_OPTION
//--------------------------------------------------------------
// IvV\(fobOp)
//
// 
//  VS4UOPTION *option	IvV
//
// ߂l
//  Ȃ
//
// Tv
//  IvV\B
//--------------------------------------------------------------
void Vs4uPrintOption( VS4UOPTION *option )
{
	printf( "----------------------------------------\n" );

	printf( "̓t@C:%s\n", option->inputWaveFile );
	printf( "o̓t@C:%s\n", option->outputWaveFile );
	printf( "Wg\:%s\n", option->frqFile );
	printf( "Ǝg\:%s\n", option->vsfrqFile );

	printf( "o͉K:%d\n", option->noteNum );
	printf( "ItZbg:%f\n", option->offset );
	printf( "v:%f\n", option->reqLength );
	printf( "q:%f\n", option->fixedLength );
	printf( "uN:%f\n", option->endBlank );
	printf( "qx:%f\n", option->fixSpeed );
	
	printf( "{[:%f\n", option->volume );
	printf( "W[V:%f\n", option->modulation );

	printf( "tH}gȂtO:%d\n", option->noFormantFlg );
	printf( "WF_[t@N^[:%d\n", option->genderFactor );
	printf( "g\č쐬tO:%d\n", option->reGenerateFrqFlg );
	printf( "sb`:%d\n", option->pitchShift );

	printf( "sb`xhf[^:%d\n", option->nPitchBend );
	printf( "e|:%f\n", option->tempo );

#if 0
	printf( "sb`xhf[^:" );
	for( int i=0; i<option->nPitchBend; i++ ){
		printf( "%d,", option->pitchBend[i] );
	}
	printf( "\n" );
#endif

	printf( "----------------------------------------\n" );
}
#endif // PRINT_OPTION
